/**
 * Redistribution and use of this software and associated
 * documentation ("Software"), with or without modification, are
 * permitted provided that the following conditions are met:
 *
 * 1. Redistributions of source code must retain copyright statements
 *    and notices.  Redistributions must also contain a copy of this
 *    document.
 *
 * 2. Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *
 * 3. The name "Exolab" must not be used to endorse or promote
 *    products derived from this Software without prior written
 *    permission of Intalio Inc.  For written permission, please
 *    contact info@exolab.org.
 *
 * 4. Products derived from this Software may not be called "Exolab"
 *    nor may "Exolab" appear in their names without prior written
 *    permission of Intalio Inc. Exolab is a registered trademark of
 *    Intalio Inc.
 *
 * 5. Due credit should be given to the Exolab Project
 *    (http://www.exolab.org/).
 *
 * THIS SOFTWARE IS PROVIDED BY INTALIO AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
 * PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL INTALIO OR
 * ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
 * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
 * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * Copyright 2000 (C) Intalio Inc. All Rights Reserved.
 *
 * $Id: IIOPClientRequest.java,v 1.12 2001/08/13 03:47:33 wood Exp $
 *
 * Date         Author  Changes
 */

package org.openorb.iiop;

import java.io.IOException;

import org.openorb.io.BufferSource;
import org.openorb.net.*;

import org.openorb.CORBA.SystemExceptionHelper;

/**
 *
 * @author <a href="mailto:wood@intalio.com">Chris Wood &lt;wood@intalio.com&gt;</a>
 * @version $Revision: 1.12 $ $Date: 2001/08/13 03:47:33 $ 
 */
class IIOPClientRequest extends AbstractClientRequest {

  /**
   * Creates a request
   */
  IIOPClientRequest(int req_id, org.omg.CORBA.Object target, Address address,
                    Object tpAssc, IIOPClientChannel channel, String operation,
                    boolean response_expected)
  {
    super(req_id, target, address, tpAssc, channel);

    _channel = channel;
    _operation = operation;
    _responseExpected = response_expected;

    if(_responseExpected)
			_syncScope = 3; /* org.omg.Messaging.SYNC_WITH_TARGET.value */
    else {
      // TODO: find the sync scope.
	/*Changed by Diana on 7 feb. 2002 from 2 to 0*/
      _syncScope = 0;
    }

    _clientManager = (org.openorb.PI.ClientManager)((org.openorb.CORBA.ORB)orb()).getFeature("ClientInterceptorManager");
    //System.out.println("Create new simple ClientManager "+orb());
    if(_clientManager != null){
	//System.out.println("create callback");
	_callback = new IIOPRequestCallback();
    }
    //else System.out.println("Cl man. It is null");
  }


 

  /**
   * Create a locate_request.
   */
  IIOPClientRequest(int req_id, int retention_id,String client_id,org.omg.CORBA.Object target, Address address,
                    Object tpAssc, IIOPClientChannel channel)
  {
    super(req_id, retention_id,client_id,target, address, tpAssc, channel);

    _channel = channel;
    _operation = null;
    _responseExpected = true;
    _syncScope = -1;
  }


    /*Added by Diana on 2 feb. 2002*/

      IIOPClientRequest(int req_id, int retention_id,String client_id,org.omg.IOP.ServiceContext one_sc,org.omg.CORBA.Object target, Address address,
                    Object tpAssc, IIOPClientChannel channel)
  {
    super(req_id, retention_id,client_id,target, address, tpAssc, channel);

    _channel = channel;
    _operation = null;
    _responseExpected = true;
    _syncScope = -1;
    add_request_service_context(one_sc,true);
  }

      /**
   * Creates a request
   */
  IIOPClientRequest(int req_id, int retention_id,String client_id,org.omg.CORBA.Object target, Address address,
                    Object tpAssc, IIOPClientChannel channel, String operation,
                    boolean response_expected)
  {
    super(req_id, retention_id,client_id,target, address, tpAssc, channel);

    _channel = channel;
    _operation = operation;
    _responseExpected = response_expected;

    if(_responseExpected)
	_syncScope = 3; /* org.omg.Messaging.SYNC_WITH_TARGET.value */
    else {
	// TODO: find the sync scope.
	/* Changed by Diana on 7 feb. 2002 form 2 to 0*/
	_syncScope = 0;
    }

    _clientManager = (org.openorb.PI.ClientManager)((org.openorb.CORBA.ORB)orb()).getFeature("ClientInterceptorManager");

    if(_clientManager != null)
			_callback = new IIOPRequestCallback();
  }


    /* Added by Diana on feb 2 2002*/

      IIOPClientRequest(int req_id, int retention_id,String client_id,org.omg.IOP.ServiceContext one_sc,org.omg.CORBA.Object target, Address address,
                    Object tpAssc, IIOPClientChannel channel, String operation,
                    boolean response_expected)
  {
    super(req_id, retention_id,client_id,target, address, tpAssc, channel);

    _channel = channel;
    _operation = operation;
    _responseExpected = response_expected;

    if(_responseExpected)
			_syncScope = 3; /* org.omg.Messaging.SYNC_WITH_TARGET.value */
    else {
      // TODO: find the sync scope.
	/* Changed by Diana on 7 feb. 2002 form 2 to 0*/
      _syncScope =0;
    }

    _clientManager = (org.openorb.PI.ClientManager)((org.openorb.CORBA.ORB)orb()).getFeature("ClientInterceptorManager");

    if(_clientManager != null)
			_callback = new IIOPRequestCallback();
    add_request_service_context(one_sc,true);
  }


    /* Modif. by Diana on Oct. 28 2001*/
      /**
   * Create a locate_request.
   */
  IIOPClientRequest(int req_id, int retention_id,String client_id,long request_start_time,org.omg.CORBA.Object target, Address address,
                    Object tpAssc, IIOPClientChannel channel)
  {
    super(req_id, retention_id,client_id,request_start_time,target, address, tpAssc, channel);

    _channel = channel;
    _operation = null;
    _responseExpected = true;
    _syncScope = -1;
  }


      /**
   * Creates a request
   */
  IIOPClientRequest(int req_id, int retention_id,String client_id,long request_start_time,org.omg.CORBA.Object target, Address address,
                    Object tpAssc, IIOPClientChannel channel, String operation,
                    boolean response_expected)
  {
    super(req_id, retention_id,client_id,request_start_time,target, address, tpAssc, channel);

    _channel = channel;
    _operation = operation;
    _responseExpected = response_expected;

    if(_responseExpected)
			_syncScope = 3; /* org.omg.Messaging.SYNC_WITH_TARGET.value */
    else {
      // TODO: find the sync scope.
	/* Changed by Diana on 7 feb. 2002 form 2 to 0*/
      _syncScope = 0;
    }

    _clientManager = (org.openorb.PI.ClientManager)((org.openorb.CORBA.ORB)orb()).getFeature("ClientInterceptorManager");

    if(_clientManager != null)
			_callback = new IIOPRequestCallback();
  }


    /* Added by Diana on 2 feb. 2002*/

  IIOPClientRequest(int req_id, int retention_id,String client_id,long request_start_time,org.omg.IOP.ServiceContext one_sc,org.omg.CORBA.Object target, Address address,
                    Object tpAssc, IIOPClientChannel channel, String operation,
                    boolean response_expected)
  {
    super(req_id, retention_id,client_id,request_start_time,target, address, tpAssc, channel);

    _channel = channel;
    _operation = operation;
    _responseExpected = response_expected;

    if(_responseExpected)
			_syncScope = 3; /* org.omg.Messaging.SYNC_WITH_TARGET.value */
    else {
      // TODO: find the sync scope.
	/* Changed by Diana on 7 feb. 2002 form 2 to 0*/
      _syncScope = 0;
    }

    _clientManager = (org.openorb.PI.ClientManager)((org.openorb.CORBA.ORB)orb()).getFeature("ClientInterceptorManager");

    if(_clientManager != null)
			_callback = new IIOPRequestCallback();
    add_request_service_context(one_sc,true);
  }


  IIOPClientRequest(int req_id, int retention_id,String client_id,org.omg.Dynamic.Parameter[] arguments,org.omg.CORBA.Object target, Address address,
                    Object tpAssc, IIOPClientChannel channel)
  {
    super(req_id, retention_id,client_id,arguments,target, address, tpAssc, channel);

    _channel = channel;
    _operation = null;
    _responseExpected = true;
    _syncScope = -1;
  }


      /**
   * Creates a request
   */
  IIOPClientRequest(int req_id, int retention_id,String client_id,org.omg.Dynamic.Parameter[] arguments,org.omg.CORBA.Object target, Address address,
                    Object tpAssc, IIOPClientChannel channel, String operation,
                    boolean response_expected)
  {
    super(req_id, retention_id,client_id,arguments,target, address, tpAssc, channel);

    _channel = channel;
    _operation = operation;
    _responseExpected = response_expected;

    if(_responseExpected)
			_syncScope = 3; /* org.omg.Messaging.SYNC_WITH_TARGET.value */
    else {
      // TODO: find the sync scope.
	/* Changed by Diana on 7 feb. 2002 form 2 to 0*/
      _syncScope = 0;
    }

    _clientManager = (org.openorb.PI.ClientManager)((org.openorb.CORBA.ORB)orb()).getFeature("ClientInterceptorManager");

    if(_clientManager != null)
			_callback = new IIOPRequestCallback();
  }

    /* new version by Diana oct. 10 2001*/

 IIOPClientRequest(int req_id, int retention_id,String client_id,org.omg.Dynamic.Parameter[] arguments,org.omg.CORBA.TypeCode[] exceptions,org.omg.CORBA.Any result,org.omg.CORBA.Object target, Address address,
                    Object tpAssc, IIOPClientChannel channel)
  {
    super(req_id, retention_id,client_id,arguments,exceptions,result,target, address, tpAssc, channel);

    _channel = channel;
    _operation = null;
    _responseExpected = true;
    _syncScope = -1;
  }


      /**
   * Creates a request
   */
  IIOPClientRequest(int req_id, int retention_id,String client_id,org.omg.Dynamic.Parameter[] arguments,org.omg.CORBA.TypeCode[] exceptions,org.omg.CORBA.Any result,org.omg.CORBA.Object target, Address address,
                    Object tpAssc, IIOPClientChannel channel, String operation,
                    boolean response_expected)
  {
    super(req_id, retention_id,client_id,arguments,exceptions,result,target, address, tpAssc, channel);

    _channel = channel;
    _operation = operation;
    _responseExpected = response_expected;

    if(_responseExpected)
			_syncScope = 3; /* org.omg.Messaging.SYNC_WITH_TARGET.value */
    else {
      // TODO: find the sync scope.
	/* Changed by Diana on 7 feb. 2002 form 2 to 0*/
      _syncScope = 0;
    }

    _clientManager = (org.openorb.PI.ClientManager)((org.openorb.CORBA.ORB)orb()).getFeature("ClientInterceptorManager");

    if(_clientManager != null)
			_callback = new IIOPRequestCallback();
  }

 


    /* new version by Diana oct. 28 2001*/

 IIOPClientRequest(int req_id, int retention_id,String client_id,long request_start_time,org.omg.Dynamic.Parameter[] arguments,org.omg.CORBA.TypeCode[] exceptions,org.omg.CORBA.Any result,org.omg.CORBA.Object target, Address address,
                    Object tpAssc, IIOPClientChannel channel)
  {
    super(req_id, retention_id,client_id,request_start_time,arguments,exceptions,result,target, address, tpAssc, channel);

    _channel = channel;
    _operation = null;
    _responseExpected = true;
    _syncScope = -1;
  }


      /**
   * Creates a request
   */
  IIOPClientRequest(int req_id, int retention_id,String client_id,long request_start_time,org.omg.Dynamic.Parameter[] arguments,org.omg.CORBA.TypeCode[] exceptions,org.omg.CORBA.Any result,org.omg.CORBA.Object target, Address address,
                    Object tpAssc, IIOPClientChannel channel, String operation,
                    boolean response_expected)
  {
    super(req_id, retention_id,client_id,request_start_time,arguments,exceptions,result,target, address, tpAssc, channel);

    _channel = channel;
    _operation = operation;
    _responseExpected = response_expected;

    if(_responseExpected)
			_syncScope = 3; /* org.omg.Messaging.SYNC_WITH_TARGET.value */
    else {
      // TODO: find the sync scope.
	/* Changed by Diana on 7 feb. 2002 form 2 to 0*/
      _syncScope = 0;
    }

    _clientManager = (org.openorb.PI.ClientManager)((org.openorb.CORBA.ORB)orb()).getFeature("ClientInterceptorManager");

    if(_clientManager != null)
			_callback = new IIOPRequestCallback();
  }

 


  /**
   * Create a locate_request.
   */
  IIOPClientRequest(int req_id, org.omg.CORBA.Object target, Address address,
                    Object tpAssc, IIOPClientChannel channel)
  {
    super(req_id, target, address, tpAssc, channel);

    _channel = channel;
    _operation = null;
    _responseExpected = true;
    _syncScope = -1;
    //System.out.println("not Create new simple ClientManager");
  }

  // request state
  private IIOPClientChannel _channel;
  private boolean _responseExpected;
  private String _operation;
  private short _syncScope;

  //modify 21 jun 2002 
    private SystemExceptionHelper sysExcHel=new SystemExceptionHelper();
  
  // interceptor stuff
  private org.openorb.PI.ClientManager _clientManager = null;
  private org.openorb.PI.RequestCallback _callback = null;

  // synchronize access to all the nonvolitile state variables (below here)
  private Object _syncState = new Object();

  private int _state = STATE_CREATED;

  private org.omg.CORBA_2_3.portable.OutputStream _requestStream;

  // reply state.
  private short _replyStatus = REPLY_STATUS_UNSET;
  private org.omg.IOP.ServiceContext [] _replyServiceContexts;

  private org.omg.CORBA_2_3.portable.InputStream _responseStream,_specialResponseStream=null;
  private boolean _responseArrived = false;
	private boolean _lastResponseArrived = false;

  private org.omg.CORBA.Object _forwardReference;
  private org.omg.IOP.IOR _forwardReferenceIOR;

  private org.omg.CORBA.SystemException _recievedSystemException;
  private org.omg.CORBA.Any _recievedSystemExceptionAny = null;
  private String _recievedExceptionID;

	// reply source. 
  private BufferSource _replySource = null;
  		
	private static final short REPLY_STATUS_UNSET = Short.MIN_VALUE;
	
  /**
   * Current request state.
   */
  public int state() {
    return _state;
  }


    public void response_stream(org.omg.CORBA.portable.InputStream is){
	_responseStream=(org.omg.CORBA_2_3.portable.InputStream)is;
    }

  /**
   * This returns true if this request is a standard request.
   *
   * While in the CREATED state it is valid to call any client request
   * info operations which would be valid in the client side
   * interception points send_request. The send_request interception
   * points are called while in this state.
   */
  public boolean is_request() {
    return (_operation != null);
  }

  /**
   * This returns true if this request is a locate request.
   *
   * Client side interceptors are not called for locate requests.
   *
   * ClientRequestInfo operations: arguments, exceptions, contexts,
   * operation_context, result, get_request_service_context,
   * get_reply_service_context, add_request_service_context are not valid.
   *
   * operation returns the empty string "", response_expected returns true.
   *
   * Note the extra value for reply_status, UNKNOWN_OBJECT.
   */
  public boolean is_locate() {
    return (_operation == null);
  }

  /**
   * Request is a poll.
   *
   * While in the CREATED state it is valid to call any client request
   * info operations which would be valid in the client side
   * interception points send_poll. The send_poll interception
   * points are called while in this state.
   */
  public boolean is_poll() {
    return false;
  }

  public short sync_scope() {
    return _syncScope;
  }

  public boolean response_expected() {
    return _responseExpected;
  }

  public String operation() {
    return (_operation == null)?"":_operation;
  }

 
    
  /**
   * Begin marshalling arguments. Valid in CREATED state. State changes to
   * MARSHAL. If no arguments are required for marshalling this can enter
   * the MARSHAL state and return null, this occours for locate requests and
   * polls only. This may also return null if entering
   * COMPLETE/SYSTEM_EXCEPTION/COMPLETED_NO, COMPLETE/LOCATION_FORWARD or
   * COMPLETE/LOCATION_FORWARD_PERMINENT due to communication problems or
   * client side interceptors. 
   */

    private class FakeMarshalListener implements org.openorb.io.MarshalBuffer.Listener{
	public void availIncreaced(org.openorb.io.MarshalBuffer buffer, int available, Object cookie){}	
	public void bufferClosed(org.openorb.io.MarshalBuffer buffer, int available, Object cookie){}
	public void bufferCanceled(org.openorb.io.MarshalBuffer buffer, org.omg.CORBA.SystemException ex, Object cookie){}
    }

    public org.omg.CORBA.portable.OutputStream begin_marshal() {
	synchronized(_syncState) {
	    switch(_state) {
	    case STATE_CREATED:
		break;
	    case STATE_MARSHAL:
	    case STATE_WAITING:
	    case STATE_UNMARSHAL:
		System.out.println("Throw BAD_INV_ORDER in begin marshal 1");
		throw new org.omg.CORBA.BAD_INV_ORDER(org.omg.CORBA.OMGVMCID.value | 10, state_completion_status());
	    case STATE_COMPLETE:
		return null;
	    default:
		System.out.println("Assert invalid state 1");
		org.openorb.util.Trace.assertTrue(false, "invalid state");
	    }
	    
	    if(_clientManager != null) {
		//System.out.println("Before inv. send_request in interceptor");
		_clientManager.send_request(this, _callback);
		//System.out.println("After inv. send_request in interceptor");
		if(_replyStatus != REPLY_STATUS_UNSET) {
		    _state = STATE_COMPLETE;
		    /*added by Diana on Sep. 26 2001*/
		    if(_replyStatus==org.omg.PortableInterceptor.SUCCESSFUL.value){
			//System.out.println("Succesfull");
			java.lang.reflect.Constructor _os_ctor;
			Class [] cargs = new Class[] { org.omg.CORBA.ORB.class, org.omg.GIOP.Version.class, org.openorb.io.MarshalBuffer.class };
			_os_ctor = ((org.openorb.CORBA.ORB)orb()).getLoader().classConstructor("iiop.CDROutputStreamClass", "org.openorb.iiop.CDROutputStream", cargs);
			CDROutputStream os;
			try {
			    Object [] args = new Object[3];
			    args[0] = orb();
			    org.omg.GIOP.Version req_vers = new org.omg.GIOP.Version((byte)1, (byte)0);
			    args[1] = req_vers;
			    org.openorb.io.MarshalBuffer buf = new org.openorb.io.MarshalBuffer(new FakeMarshalListener(), this);    
			    args[2] = buf;
			    os = (CDROutputStream)_os_ctor.newInstance(args);
			    return os;
			}catch(Exception e){e.printStackTrace();return null;}
		    }
		    // no messages sent, no need to send cancel message.
		    _channel.cancel_request(this, false);
		    return null;
		}
	    }
	    
	    try {
		//System.out.println("Channel begin marshal");
		_requestStream = _channel.begin_marshal(this);
		//System.out.println("Channel begin marshal after");
	    }
	    catch(org.omg.CORBA.SystemException ex) {
		_state = STATE_COMPLETE;
		ex.completed = org.omg.CORBA.CompletionStatus.COMPLETED_NO;
		handle_system_exception(ex);
		if(_clientManager != null) {
		    System.out.println("receive exception in begin marshal "+this.received_exception_id());
		    _clientManager.receive_exception(this, _callback);
		    _clientManager = null;
		}
		return null;
	    }
	 
	    if(_state == STATE_CREATED) {
		//System.out.println("SEt stat e to MARSHAL");
		_state = STATE_MARSHAL;
		return _requestStream;
	    }
	    
	    return null;
	}
    }

    /**
   * When this returns the last fragment of the request has been
   * sent. In MARSHAL state changes to WAITING or COMPLETE. This may
   * result in entering COMPLETE/SYSTEM_EXCEPTION/COMPLETED_NO,
   * COMPLETE/LOCATION_FORWARD or COMPLETE/LOCATION_FORWARD_PERMINENT due to
   * communication problems.
   *
   * @return new state. May be WAITING or COMPLETE.
   */
    public int send_request() {
	synchronized(_syncState) {
	    switch(_state) {
	    case STATE_MARSHAL:
		//System.out.println("send_request STATE_MARSHAL");
		break;
	    case STATE_CREATED:
	    case STATE_UNMARSHAL:
		System.out.println("Throw BAD_INV_ORDER in send_request 1");
		throw new org.omg.CORBA.BAD_INV_ORDER(org.omg.CORBA.OMGVMCID.value | 10, state_completion_status());
	    case STATE_WAITING:
	    case STATE_COMPLETE:
		//System.out.println("send_request STATE_WAITING or COMPLETE "+_state+" "+STATE_WAITING);
		return _state;
	    default:
		System.out.println("Assert invalid state 2");
		org.openorb.util.Trace.assertTrue(false, "invalid state");
	    }
	    
	    try {
		//System.out.println("Cloes req_str");
		_requestStream.close();
		_state = STATE_WAITING;
	    }
	    catch(org.omg.CORBA.SystemException ex) {
		if(_state != STATE_COMPLETE) {
		    _state = STATE_COMPLETE;
		    ex.completed = org.omg.CORBA.CompletionStatus.COMPLETED_NO;
		    handle_system_exception((org.omg.CORBA.SystemException)ex.fillInStackTrace());
		    if(_clientManager != null) {
			System.out.println("receive exception in send request "+this.received_exception_id());
			_clientManager.receive_exception(this, _callback);
			_clientManager = null;
		    }
		}
	    }
	    catch(IOException ex) {
		System.out.println("Assert invalid state 3");
		org.openorb.util.Trace.assertTrue(false, "invalid state");
	    }
	    
	    if(_syncScope != 0 || _state == STATE_COMPLETE){
		//System.out.println("synchScope nto 0");
		return _state;
	    }
	    
	    // with sync sync scope of 0 there is no reply.
	    _state = STATE_COMPLETE;
	    _replyStatus = org.omg.PortableInterceptor.SUCCESSFUL.value;
	    // if(_operation.equals("invoke")) System.out.println("Before receive_reply "+(_clientManager==null));
	    if(_clientManager != null) {
		//System.out.println("Receive reply client_manager not null");
		_clientManager.receive_reply(this, _callback);
		_clientManager = null;
	    }
	    /*else
	      System.out.println("REc repl. Client manager is null");*/
	    _responseStream = (org.omg.CORBA_2_3.portable.InputStream)orb().create_output_stream().create_input_stream();
	    _replyServiceContexts = new org.omg.IOP.ServiceContext[0];
	}
	_channel.cancel_request(this, false);
	return STATE_COMPLETE;
    }

  /**
   * Poll to see if a response is available from the target. If in the WAITING
   * state this will return true if wait_for_response would not have to wait
   * for a response. In the UNMARSHAL and COMPLETE states this returns true,
   * It is illegal to call this function in all other states.
   */
  public boolean poll_response() {
    synchronized(_syncState) {
      switch(_state) {
			case STATE_WAITING:
        return _responseArrived;
			case STATE_CREATED:
			case STATE_MARSHAL:
			    System.out.println("Throw BAD_INV_ORDER in poll_response 1");
        throw new org.omg.CORBA.BAD_INV_ORDER(org.omg.CORBA.OMGVMCID.value | 10, state_completion_status());
			case STATE_UNMARSHAL:
			case STATE_COMPLETE:
        return true;
			default:
			    System.out.println("Assert invalid state 4");
        org.openorb.util.Trace.assertTrue(false, "invalid state");
        return false;
      }
    }
  }
  
  /**
   * Wait for a response from the server. When this returns either the given
   * wait_time has expired (WAITING), a response has arrived from the server
   * (UNMARSHAL or COMPLETE), a transport error has occoured (COMPLETE), or
   * for requests where no response is expected the sync scope is satisfied
   * (COMPLETE). The request state will not exit the WAITING state unless
   * this function is called.
   *
   * @param timeout Maximum amount of time to wait for response.
   *                <=0 to wait forever, > 0 for some timeout (in ms)
   * @return new state. May be WAITING, UNMARSHAL or COMPLETE.
   */
  public int wait_for_response(long timeout) {
      // System.out.println("Wait for response 1");
      synchronized(_syncState) {
	  switch(_state) {
	  case STATE_WAITING:     
	      //System.out.println("Wait for response 2");
	      break;
	  case STATE_CREATED:
	  case STATE_MARSHAL:     
	      System.out.println("Throw BAD_INV_ORDER in wia_for_response 1");
	      throw new org.omg.CORBA.BAD_INV_ORDER(org.omg.CORBA.OMGVMCID.value | 10, state_completion_status());
	  case STATE_UNMARSHAL:
	  case STATE_COMPLETE:   
	      // if(_operation.equals("invoke")) System.out.println("Wait for response 4");
        return _state;
	  default:
	      //System.out.println("Wait for response 5");
	      System.out.println("Assert invalid state 5");
	      org.openorb.util.Trace.assertTrue(false, "invalid state");
	  }
	  
	  if(!_responseArrived) {
	      try {
		  //System.out.println("Wait for response 6");
		  _syncState.wait((timeout<=0)?0:timeout);
	      }
	      catch(InterruptedException ex) {
		  // TODO: the containing request has been canceled, cancel this
		  // request. 
		  System.out.println("Interrupted crt th ");
		  Thread.currentThread().interrupt();
	      }

	      switch(_state) {
	      case STATE_WAITING:    // if(_operation.equals("invoke")) System.out.println("Wait for response 7");  
		  //System.out.println("Wait for response 88");
		  if(!_responseArrived)
		      return _state;
		  //System.out.println("Wait for response 8");
		  break;
	      case STATE_UNMARSHAL:
	      case STATE_COMPLETE:  // if(_operation.equals("invoke"))  System.out.println("Wait for response 9");
		  return _state;
	      default:
		  //System.out.println("Wait for response 10");
		  System.out.println("Assert invalid state 6");
		  org.openorb.util.Trace.assertTrue(false, "invalid state");
	      }
	  }
	  
	  _responseArrived = false;
	  
	  // we have received a response from the server.
	  switch(_replyStatus) {
	  case org.omg.PortableInterceptor.SUCCESSFUL.value:
				// return directly, interceptors called by lastReplyMessage
				// when the last bit of reply is unmarshaled.
	      /*if(_operation.equals("invoke"))*/
	      //System.out.println("Wait for response 11");
	      if(!_lastResponseArrived) {
		  /*  if(_operation.equals("invoke"))*/
		  //System.out.println("Wait for response 110");
		  _state = STATE_UNMARSHAL;
		  return _state;
	      }
				//System.out.println("Wait for response 12");
				// this occours for a void reply.
	      break;
	  case org.omg.PortableInterceptor.USER_EXCEPTION.value:
	      //System.out.println("Wait for response 13");
	      _responseStream.mark(0);
	      _recievedExceptionID = _responseStream.read_string();
	      try {
		  _responseStream.reset();
	      }
	      catch(IOException ex) {
		  org.openorb.util.Trace.assertTrue(false, ex.toString());
	      }
	      //System.out.println("Wait for response 14");
				// return directly, interceptors called by lastReplyMessage
				// when the last bit of reply is unmarshaled.
	      if(!_lastResponseArrived) {
		  _state = STATE_UNMARSHAL;
		  // if(_operation.equals("invoke")) System.out.println("Wait for response 14");
		  return _state;
	      }
				//System.out.println("Wait for response 15");
				// this occours if the exception body is empty.
	      break;
	  case org.omg.PortableInterceptor.SYSTEM_EXCEPTION.value:
	      //System.out.println("Wait for response 141");
	      _recievedExceptionID = _responseStream.read_string();
	      //modify 21 jun 2002
	      _recievedSystemException = sysExcHel.create(
								      _recievedExceptionID, "Server Exception", _responseStream.read_ulong(),
								      org.omg.CORBA.CompletionStatus.from_int(_responseStream.read_ulong()));
	      _recievedSystemExceptionAny = null;
	      // System.out.println("Wait for response 161");
	      break;
	  case org.omg.PortableInterceptor.LOCATION_FORWARD.value:
	  case org.omg.PortableInterceptor.LOCATION_FORWARD_PERMANENT.value:
	      //System.out.println("Wait for response 1515");
	      _forwardReferenceIOR = org.omg.IOP.IORHelper.read(_responseStream);
	      _forwardReference = null;
				// fallthrough     System.out.println("Wait for response 17");
	  case org.omg.PortableInterceptor.TRANSPORT_RETRY.value:
	  case UNKNOWN_OBJECT:
	  case OBJECT_HERE:    
	      //System.out.println("Wait for response 1818");
	      break;
	  default:
	      //System.out.println("Wait for response 1919");
	      System.out.println("Assert invalid state 7");
	      org.openorb.util.Trace.assertTrue(false, "invalid state");
	  }
	  
	  // last response will have arrived, call interceptors.
	  org.openorb.util.Trace.assertTrue(_lastResponseArrived);
	  _state = STATE_UNMARSHAL;
	  lastReplyMessage(_replySource);
	  //System.out.println("Wait for response 2020");
	  return _state;
      }
  }
    
    /**
   * Get the response output stream. This function is valid in the
   * UNMARSHAL state when reply_status is SUCESSFUL or USER_EXCEPTION.
   * The returned input stream may throw a system exception with status
   * COMPLETED_YES at any time.
   */
  public org.omg.CORBA.portable.InputStream receive_response() {
    synchronized(_syncState) {
      switch(_state) {
			case STATE_UNMARSHAL:return _responseStream;
			case STATE_COMPLETE:
			    if(_specialResponseStream!=null)
				return _specialResponseStream;
			    return _responseStream;
			}
      System.out.println("Throw BAD_INV_ORDER in receive_respoonse");
      throw new org.omg.CORBA.BAD_INV_ORDER(org.omg.CORBA.OMGVMCID.value | 10, state_completion_status());
    }
  }

  /**
   * handle a system exception. Synchronized access to variables synchronized
   * on sync_state must be assured.
   */
  private void handle_system_exception(org.omg.CORBA.SystemException ex) {
    _recievedSystemExceptionAny = null;
    _recievedSystemException = ex;
    //String set_cl_p=System.setProperty("java.class.path","/home/rtslab/openorb-1.2.0/TimeService-1.2.0/lib/:/home/rtslab/openorb-1.2.0/NotificationService/lib/:/home/rtslab/openorb-1.2.0/ExtendedNamingService-1.2.0/lib/:/home/rtslab/openorb-1.2.0/OpenORB-1.2.0/lib/:/home/rtslab/openorb-1.2.0/OpenORB-1.2.0/lib/openorb_tools-1.2.0.jar:/home/rtslab/openorb-1.2.0/OpenORB-1.2.0/lib/junit_3.7.jar:/home/rtslab/openorb-1.2.0/OpenORB-1.2.0/lib/xerces-J_1.4.0.jar:/home/rtslab/openorb-1.2.0/EventService-1.2.0/lib/openorb_event-1.2.0.jar:/home/rtslab/openorb-1.2.0/ExtendedNamingService-1.2.0/lib/openorb_ins-1.2.0.jar:/home/rtslab/openorb-1.2.0/ExtendedNamingService-1.2.0/lib/insplugin-1.2.0.jar:/home/rtslab/openorb-1.2.0/NotificationService/lib/openorb_notify-1.0.1.jar:/home/rtslab/openorb-1.2.0/NotificationService/lib/openorb_evaluator-1.0.0.jar:/home/rtslab/openorb-1.2.0/PersistentStateService-1.2.0/lib/openorb_pss-1.2.0.jar:/home/rtslab/openorb-1.2.0/TimeService-1.2.0/lib/openorb_time-1.2.0.jar:.:/home/rtslab/openorb-1.2.0/NotificationService/lib/log4j_core-1.0.4.jar:/home/rtslab/openorb-1.2.0/ManagementBoard-1.2.0/lib/openorb_board-1.2.0.jar:/home/rtslab/openorb-1.2.0/ManagementBoard-1.2.0/lib/jhall-1.1.1.jar:/home/rtslab/openorb-1.2.0/ManagementBoard-1.2.0/lib/jlfgr-1.0.jar:/home/rtslab/openorb-1.2.0/TransactionService-1.2.0/lib/jdbc2_0-stdext.jar:/home/rtslab/openorb-1.2.0/TransactionService-1.2.0/lib/jta_1.0.1.jar:/home/rtslab/openorb-1.2.0/TransactionService-1.2.0/lib/openorb_ots-1.2.0.jar:/home/diasz/amclasses/:/home/diasz/testclasses/:/home/diasz/Research/Experiments/trials/infrastructure/Classes/:/sw/j2sdk-1.4.0/usr/j2se/lib/dt.jar:/sw/j2sdk-1.4.0/usr/j2se/lib/tools.jar:/sw/j2sdk-1.4.0/usr/j2se/jre/lib/rt.jar");
    /* if(set_cl_p==null)
	System.out.println("OOPS !! set is null");
    else
    System.out.println("SEt cl_p is "+set_cl_p);*/
    /*String classpath=System.getProperty("java.class.path",".");
      if(classpath==null)
      System.out.println("Classpath property is null");
      else
      System.out.println("Classpath is "+classpath);*/
    System.out.println("Handle system exc. "+ex);
    try{
	//modify 21 jun 2002
	_recievedExceptionID = sysExcHel.id(ex);
    }catch(java.lang.Exception e){e.printStackTrace(new java.io.PrintStream(System.out));_recievedExceptionID="";}
    /* if(ex instanceof org.omg.CORBA.REPLY_HERE){
       _replyStatus=org.omg.PortableInterceptor.SUCCESSFUL.value;
       _responseStream=(org.omg.CORBA_2_3.portable.InputStream)((org.omg.CORBA.REPLY_HERE)ex).right_input_stream();
       }
       else*/
	_replyStatus = org.omg.PortableInterceptor.SYSTEM_EXCEPTION.value;
  }

  /**
   * This is called only by the interceptors. Synchronized access to variables synchronized
   * on sync_state must be assured.
   */
  private void handle_location_forward(org.omg.CORBA.Object forward, boolean permanent) {
    _forwardReference = forward;
    _forwardReferenceIOR = null;
    System.out.println("set reply status "+permanent);
    _replyStatus = permanent?org.omg.PortableInterceptor.LOCATION_FORWARD_PERMANENT.value:org.omg.PortableInterceptor.LOCATION_FORWARD.value;
  }

	/**
	 * Called by channel to set the source for the reply. Add the listener.
	 * When the header has been unmarshaled handle_reply will be called.
	 */
    void setReplySource(BufferSource replySource) {
	if(_replySource != null) {
	    // received multple replies. If in the middle of unmarshaling a framented
	    // reply this exception will get thrown, rather than the correct exception.
	    _replySource.setException(new org.omg.CORBA.MARSHAL("Multiple replies received",
								0, org.omg.CORBA.CompletionStatus.COMPLETED_YES));
	    return;
	}
	_replySource = replySource;
	
	try {
	    _replySource.addLastMessageProcessedListener(
							 new BufferSource.LastMessageProcessedListener() {
		public void lastMessageProcessed(BufferSource source) {
		    lastReplyMessage(source);
		}
	    });
	}
	catch(java.util.TooManyListenersException ex) {
	    org.openorb.util.Trace.assertTrue(false, "Unable to handle too many listeners");
	}
    }
    
    /**
     * Called by the socket queue when adding a new fragment and by the 
     * channel when cancelling a request.
     */
    BufferSource getReplySource() {
	return _replySource;
    }
	
	/**
   * called by the channel to set a reply.
   */
  void handle_reply(int reply_status, org.omg.IOP.ServiceContext [] reply_service_contexts,
										org.omg.CORBA_2_3.portable.InputStream response_stream)
  {
    synchronized(_syncState) {
      _replyServiceContexts = reply_service_contexts;
      _responseStream = response_stream;
			
      _responseArrived = true;
			
      if(_operation == null) {
        switch(reply_status) {
				case org.omg.GIOP.LocateStatusType_1_2._OBJECT_HERE:
          _replyStatus = OBJECT_HERE;
          break;
				case org.omg.GIOP.LocateStatusType_1_2._UNKNOWN_OBJECT:
          _replyStatus = UNKNOWN_OBJECT;
          break;
				case org.omg.GIOP.LocateStatusType_1_2._LOC_SYSTEM_EXCEPTION:
          _replyStatus = org.omg.PortableInterceptor.SYSTEM_EXCEPTION.value;
          break;
				case org.omg.GIOP.LocateStatusType_1_2._OBJECT_FORWARD:
				    //System.out.println("set repkl status false in hr");
          _replyStatus = org.omg.PortableInterceptor.LOCATION_FORWARD.value;
          break;
				case org.omg.GIOP.LocateStatusType_1_2._OBJECT_FORWARD_PERM:
				    //System.out.println("set repkl status true in hr");
          _replyStatus = org.omg.PortableInterceptor.LOCATION_FORWARD_PERMANENT.value;
          break;
				case org.omg.GIOP.LocateStatusType_1_2._LOC_NEEDS_ADDRESSING_MODE:
          _replyStatus = org.omg.PortableInterceptor.TRANSPORT_RETRY.value;
          break;
        }
      } else {
        switch(reply_status) {
				case org.omg.GIOP.ReplyStatusType_1_2._NO_EXCEPTION:
          _replyStatus = org.omg.PortableInterceptor.SUCCESSFUL.value;
          break;
				case org.omg.GIOP.ReplyStatusType_1_2._USER_EXCEPTION:
          _replyStatus = org.omg.PortableInterceptor.USER_EXCEPTION.value;
          break;
				case org.omg.GIOP.ReplyStatusType_1_2._SYSTEM_EXCEPTION:
          _replyStatus = org.omg.PortableInterceptor.SYSTEM_EXCEPTION.value;
          break;
				case org.omg.GIOP.ReplyStatusType_1_2._LOCATION_FORWARD:
				    //System.out.println("set repkl status false in hr 2");
          _replyStatus = org.omg.PortableInterceptor.LOCATION_FORWARD.value;
          break;
				case org.omg.GIOP.ReplyStatusType_1_2._LOCATION_FORWARD_PERM:
				    //System.out.println("set repkl status true in hr 2");
          _replyStatus = org.omg.PortableInterceptor.LOCATION_FORWARD_PERMANENT.value;
          break;
				case org.omg.GIOP.ReplyStatusType_1_2._NEEDS_ADDRESSING_MODE:
          _replyStatus = org.omg.PortableInterceptor.TRANSPORT_RETRY.value;
          break;
        }
      }

			_syncState.notifyAll();
    }
  }


     /**
   * Cancel the request with the specified system exception reply. This is
   * valid in any state apart from COMPLETE. This may result in cancel messages
   * being sent to the server. If this is successful state changes to
   * COMPLETED/SYSTEM_EXCEPTION. If the provided exception's status is set 
   * to null the exception thown will set the exception status according to
   * the request's state.
   *
   * @returns true if the request is succesfully canceled.
   */
    public boolean cancel(org.omg.CORBA.SystemException ex) {
	synchronized(_syncState) {
	    if(_state == STATE_COMPLETE)
		return false;
	    
	    switch(_state) {
	    case STATE_MARSHAL:
		System.out.println("case STATE_MARSHALL");
		_replyStatus = org.omg.PortableInterceptor.SYSTEM_EXCEPTION.value;   
		_state = STATE_COMPLETE;
		ex.completed = org.omg.CORBA.CompletionStatus.COMPLETED_NO;
		handle_system_exception(ex);
		if(_clientManager != null) {
		    System.out.println("receive exception in cancel "+this.received_exception_id());
		    _clientManager.receive_exception(this, _callback);
		    _clientManager = null;
		    
		}
		if(_requestStream instanceof CDROutputStream) {
		    // send the cancel message through the stream. 
		    // System.out.println("Debug the if has been chosen");
		    try {
			((CDROutputStream)_requestStream).cancel(ex);
		    }
		    catch(org.omg.CORBA.SystemException ex1) {
			// ignored.
		    }
		} else {
		    //System.out.println("Debug the else has been chosen");
		    // cancel directly. This will result in sending a cancel
		    // message, we don't know if a fragment has been sent.
		    _channel.cancel_request(this, true);
		}
		break;
	    case STATE_WAITING:
		System.out.println("case STATE_WAITING");
		if(_replySource != null) {
		    ex.completed = org.omg.CORBA.CompletionStatus.COMPLETED_YES;
		    _replySource.setException(ex);
		    // System.out.println(" debug _replySource");
		    break;
		}
		_state = STATE_COMPLETE;
		if(_channel.cancel_request(this, true))
		    {
			ex.completed = org.omg.CORBA.CompletionStatus.COMPLETED_MAYBE;
			//System.out.println("debug _chanel.cancel.request");
		    }
		else
		    {
			ex.completed = org.omg.CORBA.CompletionStatus.COMPLETED_NO;
			//System.out.println("else");
		    }
		handle_system_exception(ex);
		if(_clientManager != null) {
	  	    System.out.println("receive exception in cancel 3"+this.received_exception_id());
		    _clientManager.receive_exception(this, _callback);
		    _clientManager = null;
		}
		_syncState.notifyAll();
		break;
	    case STATE_UNMARSHAL:
		System.out.println("case STATE_unMARSHALL");
		ex.completed = org.omg.CORBA.CompletionStatus.COMPLETED_YES;
		_replySource.setException(ex);
		break;
	    }
	    
	    return true;
	}
    }

  /**
	 * Called when the last message fragment has been processed. If in the 
	 * WAITING state then this function will have been called by the IO thread,
	 * otherwise it will be called by the unmarshalling thread, either way the
	 * final state of the request can now be calculated.
	 *
	 * This function performs all interceptor handling.
   */
  private void lastReplyMessage(BufferSource source) {
		org.omg.CORBA.SystemException ex = source.getException();
    synchronized(_syncState) {
			boolean notify = false;
			_lastResponseArrived = true;
			if(_state == STATE_WAITING) {
				// this function will get recalled by wait_for_response.
			    if(ex == null){
				//if(_operation.equals("invoke")) System.out.println("Obstacle 1");
					return;
			    }
				else
					notify = true;
			}
			
			_state = STATE_COMPLETE;
			if(ex != null){
			    //System.out.println("Before handle exc");
				handle_system_exception(ex);
			}
			
			// now call the interceptors
			//if(_operation.equals("invoke")) System.out.println("2 Before receive_reply "+(_clientManager==null));
			if(_clientManager != null) { 
				switch(_replyStatus) {
				case org.omg.PortableInterceptor.SUCCESSFUL.value:
				    //System.out.println("SUCCESSFULL RECEIVE REPLY");
				    //if(_operation.equals("invoke")) System.out.println("Successful Before receive_reply "+(_clientManager==null));
					_clientManager.receive_reply(this, _callback);
					break;
				case org.omg.PortableInterceptor.SYSTEM_EXCEPTION.value:
				case org.omg.PortableInterceptor.USER_EXCEPTION.value:
				    System.out.println("receive exception in lastReplyMesssgae "+this.received_exception_id());
				    
					_clientManager.receive_exception(this, _callback);
					break;
				case org.omg.PortableInterceptor.LOCATION_FORWARD.value:
				case org.omg.PortableInterceptor.LOCATION_FORWARD_PERMANENT.value:
				case org.omg.PortableInterceptor.TRANSPORT_RETRY.value:
					_clientManager.receive_other(this, _callback);
					break;
				case UNKNOWN_OBJECT:
				case OBJECT_HERE:
					break;
				default:
				    System.out.println("Assert invalid state 8 "+_replyStatus+" "+request_id());
					org.openorb.util.Trace.assertTrue(false, "invalid state");
				}
			
				if(_replyStatus == org.omg.PortableInterceptor.SYSTEM_EXCEPTION.value)
					source.setException(_recievedSystemException);
			}
			
			if(notify) {
				// handle reply won't get called, so notify the waiting thread.
				_responseArrived = true;
				_syncState.notifyAll();
			}
		}
    // no need to call release_reply on the channel, the last fragment releases
  }
	
    public short reply_status() {
	if(_replyStatus == REPLY_STATUS_UNSET){
	    System.out.println("Throw BAD_INV_ORDER in repl_status");
	    throw new org.omg.CORBA.BAD_INV_ORDER(org.omg.CORBA.OMGVMCID.value | 10, state_completion_status());
	}
	    return _replyStatus;
  }

  public org.omg.IOP.ServiceContext get_reply_service_context(int id) {
      if(_replyServiceContexts == null){
	  System.out.println("throw BAD_INV_ORDER in get_reply_serv_context 1");
	  throw new org.omg.CORBA.BAD_INV_ORDER(org.omg.CORBA.OMGVMCID.value | 10, state_completion_status());
      }
      switch(_state) {
      case STATE_UNMARSHAL:
      case STATE_COMPLETE:
	  for(int i = 0; i < _replyServiceContexts.length; ++i)
	      if(_replyServiceContexts[i].context_id == id)
		  return _replyServiceContexts[i];
	  throw new org.omg.CORBA.BAD_PARAM(org.omg.CORBA.OMGVMCID.value | 23, state_completion_status());
      }
      System.out.println("throw BAD_INV_ORDER in get_reply_serv_context 2");
      throw new org.omg.CORBA.BAD_INV_ORDER(org.omg.CORBA.OMGVMCID.value | 10, state_completion_status());
  }

  public org.omg.CORBA.Object forward_reference() {
    switch(reply_status()) {
		case org.omg.PortableInterceptor.LOCATION_FORWARD.value:
		case org.omg.PortableInterceptor.LOCATION_FORWARD_PERMANENT.value:
      if(_forwardReference == null)
				_forwardReference = new org.openorb.CORBA.ObjectStub(orb(), _forwardReferenceIOR);
      return _forwardReference;
    }
    System.out.println("throw BAD_INV_ORDER in forward_reference");
    throw new org.omg.CORBA.BAD_INV_ORDER(org.omg.CORBA.OMGVMCID.value | 10, state_completion_status());
  }

  /**
   * Get the ior associated with a forward reference. Calling this function
   * instead of forward_reference avoids creating an enclosing delegate/object.
   * This function is valid in the COMPLETE/LOCATION_FORWARD and
   * COMPLETE/LOCATION_FORWARD_PERMANENT states.
   */
  public org.omg.IOP.IOR forward_reference_ior() {
    // reply_status throws bad inv order if not in complete state.
    switch(reply_status()) {
		case org.omg.PortableInterceptor.LOCATION_FORWARD.value:
		case org.omg.PortableInterceptor.LOCATION_FORWARD_PERMANENT.value:
      if(_forwardReferenceIOR == null) {
        if(_forwardReference == null || !(_forwardReference instanceof org.omg.CORBA.portable.ObjectImpl))
          throw new org.omg.CORBA.INTERNAL("Forward object is unknown type");
        org.omg.CORBA.portable.Delegate deleg = ((org.omg.CORBA.portable.ObjectImpl)_forwardReference)._get_delegate();
        if(deleg == null || !(deleg instanceof org.openorb.CORBA.Delegate))
          throw new org.omg.CORBA.INTERNAL("Object delegate is unknown type");
        _forwardReferenceIOR = ((org.openorb.CORBA.Delegate)deleg).ior();
      }          
      return _forwardReferenceIOR;
    }
    System.out.println("throw BAD_INV_ORDER in forward_reference_ior");
	  
    throw new org.omg.CORBA.BAD_INV_ORDER(org.omg.CORBA.OMGVMCID.value | 10, state_completion_status());
  }

  /**
   * Get the system exception which would be contained in the any returned
   * from receive_exception. This function is valid in the
   * COMPLETE/SYSTEM_EXCEPTION state.
   */
  public org.omg.CORBA.SystemException received_system_exception() {
    // reply_status throws bad inv order if not in complete state.
    synchronized(_syncState) {
      if(reply_status() == org.omg.PortableInterceptor.SYSTEM_EXCEPTION.value)
        return _recievedSystemException;
    }
    System.out.println("throw BAD_INV_ORDER in received_system_exception");
    throw new org.omg.CORBA.BAD_INV_ORDER(org.omg.CORBA.OMGVMCID.value | 10, state_completion_status());
  }

  public org.omg.CORBA.Any received_exception() {
    // reply_status throws bad inv order if not in complete state.
    switch(reply_status()) {
    case org.omg.PortableInterceptor.SYSTEM_EXCEPTION.value:
	if(_recievedSystemExceptionAny == null) {
	    _recievedSystemExceptionAny = orb().create_any();
	    //modify 21 jun 2002
	    sysExcHel.insert(_recievedSystemExceptionAny, _recievedSystemException);
	}
	return _recievedSystemExceptionAny;
    case org.omg.PortableInterceptor.USER_EXCEPTION.value:
	throw new org.omg.CORBA.NO_RESOURCES(org.omg.CORBA.OMGVMCID.value | 1, state_completion_status());
    }
    System.out.println("throw BAD_INV_ORDER in reeived_exception");
    throw new org.omg.CORBA.BAD_INV_ORDER(org.omg.CORBA.OMGVMCID.value | 10, state_completion_status());
  }
  
  public String received_exception_id() {
    // reply_status throws bad inv order if not in complete state.
    switch(reply_status()) {
		case org.omg.PortableInterceptor.SYSTEM_EXCEPTION.value:
		case org.omg.PortableInterceptor.USER_EXCEPTION.value:
      return _recievedExceptionID;
    }
    System.out.println("throw BAD_INV_ORDER in received_exception_id");
    throw new org.omg.CORBA.BAD_INV_ORDER(org.omg.CORBA.OMGVMCID.value | 10, state_completion_status());
  }

  /**
   * We define the finalize method so that the request is canceled if a 
   * deferred request is discarded.
   */
  protected void finalize() throws java.lang.Throwable {
    cancel(new org.omg.CORBA.TIMEOUT());
  }
  
  private class IIOPRequestCallback implements org.openorb.PI.RequestCallback {
    public void reply_system_exception(org.omg.CORBA.SystemException ex) {
      handle_system_exception(ex);
    }

    public void reply_location_forward(org.omg.CORBA.Object forward, boolean permanent) {
      handle_location_forward(forward, permanent);
    }
    
    public void reply_runtime_exception(java.lang.RuntimeException ex) {
      // TODO: set the minor code to be 'unknown exception in interceptor'
			org.omg.CORBA.portable.UnknownException uex = new org.omg.CORBA.portable.UnknownException(ex);
			uex.completed = state_completion_status();
      handle_system_exception(uex);
    }
    
    public void reply_error(java.lang.Error ex) {
      if(ex instanceof ThreadDeath)
        throw ex;
      else if(ex instanceof OutOfMemoryError)
        handle_system_exception(new org.omg.CORBA.NO_MEMORY());
      else if(ex instanceof StackOverflowError)
        handle_system_exception(new org.omg.CORBA.NO_RESOURCES("Stack Overflow",
					IIOPMinorCodes.NO_RESOURCES_STACK_OVERFLOW, state_completion_status()));
      else {
        // TODO: set the minor code to be 'unknown exception in interceptor'
				org.omg.CORBA.portable.UnknownException uex = new org.omg.CORBA.portable.UnknownException(ex);
				uex.completed = state_completion_status();
        handle_system_exception(uex);
      }
    }
  }
}    
